<template>
  <div>
    <div id="nav">
      <ul>
        <li id="left">
          <ul class="breadcrumb">
            <li v-for="(br, index) in bread" :key="index">
              <a
                href="javascript:void(0)"
                v-on:click="
                  bread.splice(index + 1, bread.length);
                  page = tabs.find(e => e.name == br);
                "
              >{{ br }}</a>
            </li>
          </ul>
        </li>
        <li id="right">
          <ul class="links">
            <li>
              <a href="javascript:void(0)" id="log-click"
              v-on:click="(logged())?logout():loginStart()">Login</a>
            </li>
            <li>
              <a
                href="javascript:void(0)"
                v-on:click="
                  page = tabs.find(e => e.name == 'Info');
                  checkBread('Info');
                "
              >Info</a>
            </li>
            <li>
              <a
                href="javascript:void(0)"
                v-on:click="
                  page = tabs.find(e => e.name == 'Contact');
                  checkBread('Contact');
                "
              >Contact</a>
            </li>
            <li v-if="user.auth === 'admin'">
              <router-link to="/admin" id="last">admin</router-link>
            </li>
          </ul>
        </li>
      </ul>
    </div>
    <component
      v-bind:is="page.component"
      v-bind:user="user"
      v-on:change-component="
        changeComponent($event);
        checkBread($event);
      "
      v-on:not-logged="message($event)"
      v-on:object="delivery = $event"
      v-bind:deliveryTrack="delivery"
    ></component>
    <div id="login" class="white_content">
      <form>
        <div id="login-err" class="err"><p>username or password are incorrect</p></div>
        <div class="form-content">
          <input type="email" class="form-value" id="email-log"
          placeholder="e-mail" v-model="log.userName"/>
        </div>
        <div class="form-content">
          <input type="password" class="form-value" id="pass-log" placeholder="password"
          v-model="log.password"/>
        </div>
        <div class="form-content" id="buttons">
          <input type="button" value="login" id="log" class="form-button" v-on:click="login()" />
          <div id="link-log">
            <a href="javascript:void(0)" class="form-link"
            v-on:click="registration()">Register</a>
            <a href="javascript:void(0)" class="form-link"
            v-on:click="password()">Forgot Password?</a>
          </div>
        </div>
      </form>
    </div>
    <div id="fade" class="black_overlay" @click="fadeAll()"></div>
    <div id="register" class="white_content">
      <form>
      <div class="form-content">
        <label class="form-label">Name</label>
        <input type="text" id="name" class="form-value"  v-model="recipient.name"/>
      </div>
      <div class="err" id="name-err">
        <p style="color: red;">Name shouldn't contain numbers, or being empty!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Last Name</label>
        <input type="text" id="last" class="form-value" v-model="recipient.lastName"/>
      </div>
      <div class="err" id="last-err">
        <p style="color: red;">Last name shouldn't contain numbers
          or being empty!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">E-mail</label>
        <input type="email" id="email" class="form-value" v-model="recipient.email"/>
      </div>
      <div class="err" id="email-err">
        <p style="color: red;">Email error or email is empty!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Phone</label>
        <input type="tel" id="phone" class="form-value" v-model="recipient.phone"/>
      </div>
      <div class="err" id="phone-err">
        <p style="color: red;">Phone error or empty!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Street</label>
        <input type="text" id="street" class="form-value" v-model="recipient.street"/>
      </div>
      <div class="err" id="street-err">
        <p style="color: red;">Street shouldn't be empty!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Zip Code</label>
        <select class="form-value" id="zip" v-model="recipient.zipCodeId">
          <option selected>---------</option>
          <option v-for="zipCode in zipCodes" :key="zipCode.id" :item="zipCode"
          :value="zipCode.id">
            {{zipCode.zipCode}}, {{zipCode.city}}
          </option>
        </select>
      </div>
      <div class="form-content">
        <label class="form-label">Password</label>
        <input id="pass" type="text" class="form-value" v-model="user.password"/>
      </div>
      <div class="err" id="pass-err">
        <p style="color: red;">Password should have more than 8 characters</p>
      </div>
      <div class="form-content">
        <label class="form-label">Repeat Password</label>
        <input id="repeat" type="text" class="form-value" v-on:keyup="checkPass()"/>
      </div>
      <div class="err" id="repeat-err">
        <p style="color: red;">Passwords should be the same</p>
      </div>
      <div class="err" id="zip-err">
        <p style="color: red;">Please slect one!</p>
      </div>
        <div class="form-content" id="buttons">
          <input type="button" value="Submit" class="form-button" v-on:click="register()"/>
        </div>
      </form>
    </div>
    <div id="pass-forgot" class="white_content">
      <p>
        Plase give us your e-mail,
        <br />we will sent a message to reset you password
      </p>
      <form>
        <div class="form-content">
          <input type="email" class="form-value" placeholder="e-mail" />
        </div>
        <div class="form-content" id="buttons">
          <input type="button" value="Submit" class="form-button" v-on:click="sendMail()" />
        </div>
      </form>
    </div>
    <div id="message-sent" class="white_content">
      <p id="message"></p>
      <a id="gotIt" v-on:click="fadeAll()">Got it!!</a>
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import md5 from 'md5';
import details from '../components/details.vue';
import home from '../components/home.vue';
import contact from '../components/contact.vue';
import trackRecieve from '../components/trackRecieve.vue';
import trackSent from '../components/trackSent.vue';
import info from '../components/info.vue';

export default {
  name: 'defaultNav',
  data() {
    return {
      tabs: [
        { name: 'Home', component: home },
        { name: 'Details', component: details },
        { name: 'Contact', component: contact },
        { name: 'Tracking', component: trackRecieve },
        { name: 'Tracking sent', component: trackSent },
        { name: 'Info', component: info },
      ],
      page: {},
      bread: ['Home'],
      user: {},
      delivery: String,
      recipient: {},
      log: {},
      zipCodes: [],
    };
  },
  created() {
    this.page = this.tabs.find(e => e.name === 'Home');
  },
  mounted() {
    this.get();
  },
  methods: {
    changeComponent(event) {
      this.page = this.tabs.find(e => e.name === event);
      document.getElementById('nav').scrollIntoView();
    },
    checkBread(event) {
      if (this.bread.length >= 2) {
        const reg = /(Tracking).*/;
        if (reg.test(this.bread[-1]) && event === 'Details') {
          this.bread.push(event);
        } else if (this.bread.indexOf(event) === -1) {
          this.bread.splice(1, this.bread.length - 1);
          this.bread.push(event);
        }
      } else if (this.bread.indexOf(event) === -1) {
        this.bread.push(event);
      }
    },
    loginStart() {
      document.getElementById('fade').style.display = 'block';
      document.getElementById('login').style.display = 'block';
    },
    fadeAll() {
      document.getElementById('login').style.display = 'none';
      document.getElementById('register').style.display = 'none';
      document.getElementById('pass-forgot').style.display = 'none';
      document.getElementById('message-sent').style.display = 'none';
      document.getElementById('fade').style.display = 'none';
    },
    message(event) {
      document.getElementById('message').textContent = event;
      document.getElementById('fade').style.display = 'block';
      document.getElementById('message-sent').style.display = 'block';
      document.getElementById('nav').scrollIntoView();
    },
    registration() {
      document.getElementById('fade').style.display = 'block';
      document.getElementById('register').style.display = 'block';
    },
    password() {
      document.getElementById('fade').style.display = 'block';
      document.getElementById('pass-forgot').style.display = 'block';
    },
    login() {
      axios.get(`http://localhost:4000/api/users/username/${this.log.userName}`).then(
        (result) => {
          this.user = result.data;
        },
      ).catch((error) => {
        console.log(error);
        this.loginError();
      });
      if (this.user.password !== md5(this.log.password)) {
        this.loginError();
        this.user = {};
      } else {
        this.fadeAll();
        document.getElementById('log-click').text = 'Logout';
      }
    },
    loginError() {
      document.getElementById('email-log').style.borderColor = 'red';
      document.getElementById('pass-log').style.borderColor = 'red';
      document.getElementById('login-err').style.dysplay = 'block';
    },
    register() {
      if (this.checkRecipient(this.recipient)) {
        axios.post('http://localhost:4000/api/recipients', {
          name: this.recipient.name,
          lastName: this.recipient.lastName,
          email: this.recipient.email,
          phone: this.recipient.phone,
          zipCodeId: this.recipient.zipCodeId,
          street: this.recipient.street,
        }).then(
          (result) => {
            console.log(result.data);
            axios.get('http://localhost:4000/api/recipients').then(
              (resu) => {
                this.recipient = resu.data;
              },
            ).catch((error) => {
              console.log(error);
            });
          },
        ).catch((error) => {
          console.log(error);
        });
        axios.post('http://localhost:4000/api/users', {
          userName: this.recipient.email,
          password: md5(this.user.password),
          auth: 'user',
          recipientId: this.recipient.id,
        })
          .then(
            (result) => {
              console.log(result);
            },
          ).catch((error) => {
            console.log(error);
          });
        axios.post('http://localhost:4000/send-email', {
          to: this.recipient.email,
          subject: 'New password for aplication TrackingId',
          message: `Your username: ${this.recipient.email}
            Your password: ${this.user.password}`,
        })
          .then((response) => { console.log(response); })
          .catch((e) => {
            console.log(e);
          });
      }
      this.mail_message();
    },
    checkRecipient(obj) {
      const reg = /.*\d.*/;
      const reg2 = /[A-z]|[0-9]|\.|_|%|\+|-+@[A-z]|[0-9]|\.|-+\.[A-Z]{2,}/;
      const reg3 = /[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-|\s|.|0-9]*/;

      if (!this.user.password || this.user.password.length < 8) {
        document.getElementById('pass').style.borderColor = 'red';
        document.getElementById('pass-err').style.display = 'block';
      }

      if (obj.name && obj.lastName && obj.email
        && obj.phone && obj.street && obj.zipCodeId
        && !reg.test(obj.name) && !reg.test(obj.lastName)
        && reg2.test(obj.email) && reg3.test(obj.phone)) {
        return true;
      }
      if (!obj.name || reg.test(obj.name)) {
        document.getElementById('name').style.borderColor = 'red';
        document.getElementById('name-err').style.display = 'block';
      }
      if (!obj.lastName || reg.test(obj.lastName)) {
        document.getElementById('last').style.borderColor = 'red';
        document.getElementById('last-err').style.display = 'block';
      }
      if (!obj.email || !reg2.test(obj.email)) {
        document.getElementById('email').style.borderColor = 'red';
        document.getElementById('email-err').style.display = 'block';
      }
      if (!obj.phone || !reg3.test(obj.phone)) {
        document.getElementById('phone').style.borderColor = 'red';
        document.getElementById('phone-err').style.display = 'block';
      }
      if (!obj.street) {
        document.getElementById('street').style.borderColor = 'red';
        document.getElementById('street-err').style.display = 'block';
      }
      if (!obj.zipCodeId) {
        document.getElementById('zip').style.borderColor = 'red';
        document.getElementById('zip-err').style.display = 'block';
      }
      return false;
    },
    logout() {
      this.reload();
    },
    logged() {
      if (this.user.username) {
        return true;
      }
      return false;
    },
    get() {
      axios.get('http://localhost:4000/api/zipCodes').then(
        (result) => {
          this.zipCodes = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    checkPass() {
      const x = document.getElementById('pass').value;
      const y = document.getElementById('repeat').value;

      if (x === y) {
        document.getElementById('repeat').style.backgroundColor = 'green';
      } else {
        document.getElementById('repeat').style.borderColor = 'red';
        document.getElementById('repeat-err').style.display = 'block';
      }
    },
    mail_message() {
      document.getElementById('message').textContent = 'An email was sent please check!';
      document.getElementById('fade').style.display = 'block';
      document.getElementById('message-sent').style.display = 'block';
      document.getElementById('register').style.display = 'none';
      document.getElementById('nav').scrollIntoView();
    },
  },
};
</script>

<style scoped>
@import "../CSS/Default.css";
@import "../CSS/FormDefault.css";
@import "../CSS/TreeDefault.css";
@import "../CSS/TablesDefault.css";
</style>
